#include "descriptor/descriptor.h"

int main(void) {

  ITEM	glass,ceramic,brown,yellow,blu,white,black,red,grey,dark_red,standard,blue,dark_blue;
  ITEM	teapot_glass,teapot_brown,cup1,cup2,table,mo_head,mo_backpack,mo_black_body,mo_int_arms,mo_est_arms,mo_eyes,mo_alarm,mo_centre_arms,mo_yellow_eyes,mo_centre_alarm;
  ITEM      tex_arm_sx, tex_arm_dx,tex_body,backwater;
  ITEM      floor1,floor2,floor3,backwall,pavimento;
  ITEM	scene;
  ITEM      floorA1,floorB1,floorC1,floorA2,floorB2,floorC2,floorA3,floorB3,floorC3;
  ITEM      wallC1,wallC2,wallC3;
  ITEM      box1sx,box1up,box1front,box2sx,box1dx,box2up,box2front,box2dx,box2back,box3sx,box3up,box3front,box3dx,can;
  
  int i;
  
  
  /*TEXTURE*/
  char * prova = "textures/pavimento.hr";
  char * vuota = "textures/vuota.hr";
  char * box1 = "textures/box1.hr";
  char * box1f = "textures/box1front.hr";
  char * pav1 = "textures/pavimento1.hr";   
  char * pavA2 = "textures/FA2.hr";
  char * pavA1 = "textures/FA1.hr";
  char * pavA3 = "textures/FA3.hr";
  char * pavB1 = "textures/FB1.hr";
  char * pavB2 = "textures/FB2.hr";
  char * pavB3 = "textures/FB3.hr";
  char * pavC2 = "textures/FC2.hr";
  char * pav3 = "textures/pavimento3.hr";
  char * wall1 = "textures/WC2.hr";
  char * wall2 = "textures/wall3.hr";
  char * muroC3 = "textures/WC3.hr";
  char * muroC1 = "textures/WC1.hr";
  char * arm_sx = "textures/bracciosx.hr";
  char * tex_corpo = "textures/corpo2.hr";
  char * tex_centro_braccia = "textures/perno.hr";
  char * bidone = "textures/bidone.hr";

  set_background(0.676,0.861,0.953,TRUE);
  set_ambient_light(1,1,1,0.7);
  create_point_light(16.16,15.90,9.39,1,1,1,3.89,20, "light1");
  create_point_light(12,-12,9,1,1,1,4,20, "light2");
  create_point_light(2.33,-0.25,16.21,1,1,1,3.89,25, "light3");

  /*** ATTRIBUTE glass ***/
  glass = create_attribute("glass");
  set_color(glass,0.68,0.86,1,0.5,0.5);
  set_reflectivity(glass,0.24,2);
  set_transparency(glass,0.87,0.68,1,1.2);
  
  /** Attribute grey  **/
  grey = create_attribute("grey");
  set_color(grey,0.28,0.28,0.28,0.2,0.8);
  set_reflectivity(grey,0.3,10);
  
   /** Attribute dark red  **/
  dark_red = create_attribute("dark_red");
  set_color(dark_red,0.75,0.2,0.2,0.2,0.8);
  set_reflectivity(dark_red,0.3,10);
  
   /** Attribute blue  **/
  blue = create_attribute("blue");
  set_color(blue,0.427,0.812,0.925,0.2,0.8);
  set_transparency(blue,0.99,0.2,0.8,1.2);
  
   /** Attribute dark blue  **/
  dark_blue = create_attribute("dark_blue");
  set_color(dark_blue,0.035,0.643,0.824,0.2,0.8);
  set_reflectivity(dark_blue,0.3,10);
  
  
  /** Attribute white **/
  white = create_attribute("white");
  set_color(white,1,1,1,0.4,0.8);
  set_reflectivity(white,0,2);
  
  /** Attribute black **/
  black = create_attribute("black");
  set_color(black,0.2,0.2,0.2,0.1,0.8);
  set_reflectivity(black,0,0);
  
   /*** ATTRIBUTE standard ***/
  standard = create_attribute("standard");
  set_color(standard,1,1,1,0,1);
  set_reflectivity(standard,0,2);
  set_transparency(standard,0,0,0,1);

  

  /*** ATTRIBUTE ceramic ***/
  ceramic = create_attribute("ceramic");
  set_color(ceramic,0.89,0.76,0.65,0.1,0.8);
  set_reflectivity(ceramic,0.2,128);

  /*** ATTRIBUTE brown ***/
  brown = create_attribute("brown");
  set_color(brown,0.93,0.01,0.01,1,1);
  /**set_reflectivity(brown,0.17,15);**/
  set_transparency(brown,0.99,0.2,0.8,1.2);
  
   /*** ATTRIBUTE brown ***/
  red = create_attribute("red");
  set_color(red,1,0,0,1,1);
  set_reflectivity(red,0.17,15);
  set_transparency(red,0.87,0.68,1,1.2);

  /*** ATTRIBUTE yellow ***/
  yellow = create_attribute("yellow");
  set_color(yellow,1,1,0,1,1);
  set_reflectivity(yellow,0.17,15);

  /*** ATTRIBUTE blu ***/
  blu = create_attribute("blu");
  set_color(blu,0,0,1,0.5,0.5);
  set_reflectivity(blu,0.3,10);

  
  
  mo_head = read_obj("headrefined2.obj", "glass_mo");
  set_attribute(mo_head,white);
  /**set_translate(mo_head,0,0,3);**/
  /**set_scale(mo_head,1.5,1.5,1.5);**/
  
  mo_backpack = read_nurbs("zaino.db");
  set_attribute(mo_backpack,blue);
  /**set_translate(mo_white_body,0,0,3);**/
  /**set_scale(mo_white_body,1.5,1.5,1.5);**/
  
   backwater = read_nurbs("acquazaino.db");
  set_attribute(backwater,dark_blue);
  /**set_translate(mo_white_body,0,0,3);**/
  /**set_scale(mo_white_body,1.5,1.5,1.5);**/
  
  mo_black_body = read_obj("partinerecorpo.obj", "black_body");
  set_attribute(mo_black_body,black);
  /**set_translate(mo_black_body,0,0,3);**/
  /**set_scale(mo_black_body,1.5,1.5,1.5);**/
  
  mo_yellow_eyes = read_obj("occhigialli.obj", "yellow_eyes");
  set_attribute(mo_yellow_eyes,yellow);
  /**set_translate(mo_black_body,0,0,3);**/
  /**set_scale(mo_yellow_eyes,1.5,1.5,1.5);**/
  
  mo_eyes = read_nurbs("eyes1.db");
  set_attribute(mo_eyes,black);
  /**set_translate(mo_eyes,0,0,3);**/
  /**set_scale(mo_eyes,1.5,1.5,1.5);**/
  
  mo_alarm = read_nurbs("alarm1.db");
  set_attribute(mo_alarm,brown);
  /**set_translate(mo_alarm,0,0,3);**/
  /**set_scale(mo_alarm,1.5,1.5,1.5);**/
  

  
  mo_est_arms = read_obj("extarms.obj", "arms");
  set_attribute(mo_est_arms,white);
  /**set_translate(mo_arms,0,0,3);**/
  /**set_scale(mo_est_arms,1.5,1.5,1.5);**/
  
  mo_int_arms = read_obj("intarms.obj", "arms");
  set_attribute(mo_int_arms,black);
  /**set_translate(mo_arms,0,0,3);**/
  /**set_scale(mo_int_arms,1.5,1.5,1.5);**/
  
   mo_centre_alarm = read_nurbs("internosirena.db");
  set_attribute(mo_centre_alarm,dark_red);
  /**set_translate(mo_centre_arms,0,0,3);**/
  /**set_scale(mo_centre_alarm,1.5,1.5,1.5);**/
                                

  
 
  /** textured parts **/
  
  mo_centre_arms = read_nurbs("centrobraccia.db");
  set_domain_texture(mo_centre_arms,standard,tex_centro_braccia, 0, 1, 0, 1, 0, 0.6, 0.6);
  
  /**set_translate(mo_centre_arms,0,0,3);**/
  /**set_scale(mo_centre_arms,1.5,1.5,1.5);**/
  
  tex_arm_sx = read_nurbs("estarmsx.db");
   set_domain_texture(tex_arm_sx,white,arm_sx, 0, 1, 0, 1, 0, 0.4, 0.8);
  
  tex_arm_dx = read_nurbs("estarmidx.db");
  set_domain_texture(tex_arm_dx,white,arm_sx, 0, 1, 0, 1, 0, 0.4, 0.8);
  
  tex_body = read_nurbs("corpo.db");
 set_domain_texture(tex_body,white,tex_corpo, 0, 1, 0, 1, 0, 0.4, 0.8);

  floor1 = read_nurbs("paretedx.db");
  /**set_translate(table,20,20,0);**/
  set_domain_texture(floor1,standard, wall1, 0, 0.1, 0, 0.1, 1, 0.6, 0.6);
  /**set_cube_texture(table,prova,prova);**/
  /**set_translate(table,-20,-20,-3.8);**/
   /**set_scale(floor1,1.5,1.5,1.5);**/
  
  floor2 = read_nurbs("paretesx.db");
  /**set_translate(table,20,20,0);**/
  set_domain_texture(floor2,standard, wall1, 0, 0.1, 0, 0.1, 1, 0.6, 0.6);
  /**set_scale(floor2,1.5,1.5,1.5);**/
  /**set_cube_texture(table,prova,prova);**/
  /**set_translate(table,-20,-20,-3.8);**/
  
  wallC1 = read_nurbs("WC1.db");
  set_domain_texture(wallC1,standard, muroC1, 0, 1, 0, 1, 0, 0.6, 0.6);
  wallC2 = read_nurbs("wallC2.db");
  set_domain_texture(wallC2,standard, wall1, 0, 1, 0, 1, 0, 0.6, 0.6);
  wallC3 = read_nurbs("WC3.db");
  set_domain_texture(wallC3,standard, muroC3, 0, 1, 0, 1, 0, 0.6, 0.6);
 
  floorA1 = read_nurbs("FA1.db");
  set_domain_texture(floorA1,standard, pavA1, 0, 1, 0, 1, 0, 0.6, 0.6);
  floorB1 = read_nurbs("FB1.db");
  set_domain_texture(floorB1,standard, pavB1, 0, 1, 0, 1, 0, 0.6, 0.6);
   floorC1 = read_nurbs("FC1.db");
  set_domain_texture(floorC1,standard, pavB1, 0, 1, 0, 1, 0, 0.6, 0.6);
  floorA2 = read_nurbs("floorA2.db");
  set_domain_texture(floorA2,standard, pavA2, 0, 1, 0, 1, 0, 0.6, 0.6);
   floorB2 = read_nurbs("floorB2.db");
  set_domain_texture(floorB2,standard, pavB2, 0, 1, 0, 1, 0, 0.6, 0.6);
   floorC2 = read_nurbs("floorC2.db");
  set_domain_texture(floorC2,standard, pavA2, 0, 1, 0, 1, 0, 0.6, 0.6);
  floorA3 = read_nurbs("FA3.db");
  set_domain_texture(floorA3,standard, pavA3, 0, 1, 0, 1, 0, 0.6, 0.6);
  floorB3 = read_nurbs("FB3.db");
  set_domain_texture(floorB3,standard, pavB3, 0, 1, 0, 1, 0, 0.6, 0.6);
   floorC3 = read_nurbs("FC3.db");
  set_domain_texture(floorC3,standard, pavB3, 0, 1, 0, 1, 0, 0.6, 0.6);
  
  /** oggetti ambiente **/
  
  box1sx = read_nurbs("box1sx.db");
  set_domain_texture(box1sx,standard, box1, 0, 1, 0, 1, 0, 0.6, 0.6);
   box1front = read_nurbs("box1front.db");
  set_domain_texture(box1front,standard, box1f, 0, 1, 0, 1, 0, 0.6, 0.6);
   box1up = read_nurbs("box1up.db");
  set_domain_texture(box1up,standard, box1, 0, 1, 0, 1, 0, 0.6, 0.6);
   box1dx = read_nurbs("box1dx.db");
  set_domain_texture(box1dx,standard, box1, 0, 1, 0, 1, 0, 0.6, 0.6);
  box2sx = read_nurbs("box2sx.db");
  set_domain_texture(box2sx,standard, box1, 0, 1, 0, 1, 0, 0.6, 0.6);
   box2front = read_nurbs("box2front.db");
  set_domain_texture(box2front,standard, box1f, 0, 1, 0, 1, 0, 0.6, 0.6);
   box2up = read_nurbs("box2top.db");
  set_domain_texture(box2up,standard, box1, 0, 1, 0, 1, 0, 0.6, 0.6);
   box2back = read_nurbs("box2back.db");
  set_domain_texture(box2back,standard, box1, 0, 1, 0, 1, 0, 0.6, 0.6);
  box2dx = read_nurbs("box2dx.db");
  set_domain_texture(box2dx,standard, box1, 0, 1, 0, 1, 0, 0.6, 0.6);
   box3sx = read_nurbs("box3sx.db");
  set_domain_texture(box3sx,standard, box1, 0, 1, 0, 1, 0, 0.6, 0.6);
   box3front = read_nurbs("box3front.db");
  set_domain_texture(box3front,standard, box1f, 0, 1, 0, 1, 0, 0.6, 0.6);
   box3up = read_nurbs("box3top.db");
  set_domain_texture(box3up,standard, box1, 0, 1, 0, 1, 0, 0.6, 0.6);
  box3dx = read_nurbs("box3dx.db");
  set_domain_texture(box3dx,standard, box1, 0, 1, 0, 1, 0, 0.6, 0.6);
  can = read_nurbs("bidone.db");
  set_domain_texture(can,standard, bidone, 0, 1, 0, 1, 0, 0.6, 0.6);
  
  
  /**pavimento = read_nurbs("environment/pavimento.db");
  set_domain_texture(pavimento,standard, pav3, 0, 1, 0, 1, 1, 0.6, 0.6);**/

  scene = create_list(mo_backpack, "scene");
  scene = insert_in_list(scene,tex_body);
  
  /**Setting up environment**/
  scene = insert_in_list(scene,floorA1);
  scene = insert_in_list(scene,floorB1);
  scene = insert_in_list(scene,floorC1);
  scene = insert_in_list(scene,floorA2);
  scene = insert_in_list(scene,floorB2);
  scene = insert_in_list(scene,floorC2);
  scene = insert_in_list(scene,floorA3);
  scene = insert_in_list(scene,floorB3);
  scene = insert_in_list(scene,floorC3);
  scene = insert_in_list(scene,wallC1);
  scene = insert_in_list(scene,wallC2);
  scene = insert_in_list(scene,wallC3);
  
  /** objects on scene **/
  scene = insert_in_list(scene,box1sx);
  scene = insert_in_list(scene,box1front);
  scene = insert_in_list(scene,box1up);
  scene = insert_in_list(scene,box1dx);
  
  scene = insert_in_list(scene,box2sx);
  scene = insert_in_list(scene,box2front);
  scene = insert_in_list(scene,box2up);
  scene = insert_in_list(scene,box2dx);
  scene = insert_in_list(scene,box2back);
  
  scene = insert_in_list(scene,box3sx);
  scene = insert_in_list(scene,box3front);
  scene = insert_in_list(scene,box3up);
  scene = insert_in_list(scene,box3dx);
  
  scene = insert_in_list(scene,can);
  
  
 
  scene = insert_in_list(scene,mo_head);
  scene = insert_in_list(scene,mo_alarm);
  scene = insert_in_list(scene,mo_eyes);
  scene = insert_in_list(scene,mo_black_body);
  scene = insert_in_list(scene,mo_int_arms);
  /**scene = insert_in_list(scene,mo_est_arms);**/
  scene = insert_in_list(scene,tex_arm_sx);  
  scene = insert_in_list(scene,tex_arm_dx);
  scene = insert_in_list(scene,mo_centre_arms);
  scene = insert_in_list(scene,mo_yellow_eyes);
   scene = insert_in_list(scene,mo_centre_alarm);
   scene = insert_in_list(scene,backwater);
   
 

 // save_scene("mo.md","scene_mo",scene);
  /** Mo si accorge delle tracce a sx**/
  for(i=0;i<25;i++){
	  set_z_rotate(mo_head,-2,TRUE);
	  set_x_rotate(mo_head,-0.5,TRUE);
	  set_z_rotate(mo_eyes,-2,TRUE);
	  set_x_rotate(mo_eyes,-0.5,TRUE);
	  set_z_rotate(mo_yellow_eyes,-2,TRUE);
	  set_x_rotate(mo_yellow_eyes,-0.5,TRUE);
	  set_z_rotate(mo_alarm,-2,TRUE);
	  set_x_rotate(mo_alarm,-0.5,TRUE);
	  save_scene_ani(150,"mo.ani","mo","scene", scene);
  }
  for(i=0;i<5;i++)
  {
	  save_scene_ani(150,"mo.ani","mo","scene", scene);
  }
  for(i=0;i<10;i++){
	  set_z_rotate(mo_head,3,TRUE);
	  
	  set_z_rotate(mo_eyes,3,TRUE);
	  
	  set_z_rotate(mo_yellow_eyes,3,TRUE);
	  
	  set_z_rotate(mo_alarm,3,TRUE);
	  
	  save_scene_ani(150,"mo.ani","mo","scene", scene);
  }
  /** gira la testa */
  for(i=0;i<20;i++){
	  set_z_rotate(mo_head,3,TRUE);  
	  /**set_x_rotate(mo_head,0.4,TRUE);**/
	  set_z_rotate(mo_eyes,3,TRUE);
	  /**set_x_rotate(mo_eyes,0.4,TRUE);**/
	  set_z_rotate(mo_yellow_eyes,3,TRUE);
	  /**set_x_rotate(mo_yellow_eyes,0.4,TRUE);**/
	  set_z_rotate(mo_alarm,3,TRUE);
	  /**set_x_rotate(mo_alarm,0.4,TRUE);**/
	  save_scene_ani(150,"mo.ani","mo","scene", scene);
  }
  /** gira il corpo */
  for(i=0;i<30;i++){
	  set_z_rotate(mo_backpack,3,TRUE);
	  set_z_rotate(backwater,3,TRUE);
	  set_z_rotate(tex_body,3,TRUE);
	  set_z_rotate(mo_black_body,3,TRUE);
	  set_z_rotate(mo_int_arms,3,TRUE);
	  set_z_rotate(tex_arm_sx,3,TRUE);
	  set_z_rotate(tex_arm_dx,3,TRUE);
	  set_z_rotate(mo_centre_arms,3,TRUE);
	  set_z_rotate(mo_centre_alarm,3,TRUE);
	  save_scene_ani(150,"mo.ani","mo","scene", scene);
  }
  for(i=0;i<5;i++)
  {
	  save_scene_ani(150,"mo.ani","mo","scene", scene);
  }
for(i=0;i<65;i++){
	  set_translate(mo_head,-0.2,0,0);  
	  set_translate(mo_eyes,-0.2,0,0);
	  set_translate(mo_yellow_eyes,-0.2,0,0);
	  set_translate(mo_alarm,-0.2,0,0);
	  set_translate(mo_backpack,-0.2,0,0);
	  set_translate(backwater,-0.2,0,0);
	  set_translate(tex_body,-0.2,0,0);
	  set_translate(mo_black_body,-0.2,0,0);
	  set_translate(mo_int_arms,-0.2,0,0);
	  set_translate(tex_arm_sx,-0.2,0,0);
	  set_translate(tex_arm_dx,-0.2,0,0);
	  set_translate(mo_centre_arms,-0.2,0,0);
	  set_translate(mo_centre_alarm,-0.2,0,0); 
	  
	  save_scene_ani(150,"mo.ani","mo","scene", scene);
  }
  return(0);
}
